--------------------------------------------------------------------------------
-- [VHDL Praktikum SS2004]
--
-- Aufgabe 3:     Minima-Rechenwerk
-- Entity:        E_MINIMA (Top-Level-Entity)               
--
-- Andreas Schibilla (ii4900)
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity E_ADDER is    
    port (         
        CLK:      in  std_logic;
        RST:      in  std_logic;
        A_IMPULS: in  std_logic;
        B_IMPULS: in  std_logic;
        S_IN:     in  std_logic;
        BIT1_IN:  in  std_logic;
        BIT2_IN:  in  std_logic;
        S_OUT:    out std_logic
    );
end E_ADDER;


architecture A_ADDER of E_ADDER is
type t_adder is(IDLE, SETCARRY);
signal INT_CARRY     : std_logic;
signal INT_STATE     : t_adder;
begin      
                   
 -- addiere oberen Summanden (INT_SUMMAND3) mit unterem Summanden (SHIFT_IN)                   
 S_OUT      <= (BIT1_IN xor BIT2_IN) xor INT_CARRY;
                                      
 -- Prozess, um Carry vor der Rechnung zu initialisieren (bei Addition=0, bei Subtraktion=1)
 P1: process(CLK, RST, B_IMPULS, S_IN)
 begin
   if RST = '1' then                  
      INT_STATE         <= IDLE;          
   elsif rising_edge(CLK) then
      case INT_STATE is             
            when IDLE        =>  if B_IMPULS = '1' then
                                    INT_CARRY <= '0';
                                    INT_STATE <= SETCARRY;
                                 elsif A_IMPULS = '1' then
                                    INT_CARRY <= (BIT1_IN and BIT2_IN) or (INT_CARRY and (BIT1_IN or BIT2_IN) );
                                 end if;
                                 
            when SETCARRY    =>  if A_IMPULS = '1' then
                                    if S_IN = '1' then
                                       INT_CARRY <= '1';
                                    else 
                                       INT_CARRY <= (BIT1_IN and BIT2_IN) or (INT_CARRY and (BIT1_IN or BIT2_IN) );
                                    end if;
                                    INT_STATE <= IDLE;                                    
                                 end if;
      end case;
   end if;
 end process P1;    

end A_ADDER;




