--------------------------------------------------------------------------------
-- [VHDL Praktikum SS2004]
--
-- Aufgabe 3:     Minima-Rechenwerk
-- Entity:        E_MINIMA (Top-Level-Entity)               
--
-- Andreas Schibilla (ii4900)
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity E_ADDSUB is    
    port (         
        CLK:      in  std_logic;
        A_IMPULS: in  std_logic;
        B_IMPULS: in  std_logic;
        C_IMPULS: in  std_logic;
        A_IN:     in  std_logic;
        S_IN:     in  std_logic;
        C_IN:     in  std_logic;
        RAM_IN:   in  std_logic;
        BR_IN:    in  std_logic;
        S_OUT:    out std_logic
    );
end E_ADDSUB;


architecture A_ADDSUB of E_ADDSUB is

component E_VERZOEGERN is    
    port (
        CLK:         in  std_logic;
        A_IMPULS:    in  std_logic;
        B_IMPULS:    in  std_logic;
        S_IN:        in  std_logic;
        S_OUT:       out std_logic
    );
end component;

signal INT_SUMMAND1  : std_logic;
signal INT_SUMMAND2  : std_logic;

begin      

 with C_IN select
   INT_SUMMAND1  <= BR_IN and (not C_IMPULS)    when '1',
                    RAM_IN                      when '0';
                    
 INT_SUMMAND2 <= (A_IN and INT_SUMMAND1) or (S_IN and (not INT_SUMMAND1) );
 VERZOEGERN_inst : E_VERZOEGERN PORT MAP (CLK, A_IMPULS, B_IMPULS, INT_SUMMAND2, S_OUT);                   
                                      
end A_ADDSUB;




