--------------------------------------------------------------------------------
-- [VHDL Praktikum SS2004]
--
-- Aufgabe 3:     Minima-Rechenwerk
-- Entity:        E_MINIMA (Top-Level-Entity)               
--
-- Andreas Schibilla (ii4900)
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;


entity E_SHIFTING is    
    port (
        CLK:         in  std_logic;
        A_IMPULS:    in  std_logic;
        B_IMPULS:    in  std_logic;
        L_IN:        in  std_logic;
        R_IN:        in  std_logic;
        N_IN:        in  std_logic;
        S_IN:        in  std_logic;
        S_OUT:       out std_logic
    );
end E_SHIFTING;


architecture A_SHIFTING of E_SHIFTING is

component E_VERZOEGERN is    
    port (
        CLK:         in  std_logic;
        B_IMPULS:    in  std_logic;
        S_IN:        in  std_logic;
        S_OUT:       out std_logic
    );
end component;

signal INT_L1_OUT : std_logic;
signal INT_L2_OUT : std_logic;
signal INT_N_OUT  : std_logic;
signal INT_TMP    : std_logic_vector(1 downto 0);

begin      

 L1_inst : E_VERZOEGERN PORT MAP (CLK, B_IMPULS, S_IN,         INT_L1_OUT);
 L2_inst : E_VERZOEGERN PORT MAP (CLK, B_IMPULS, INT_L1_OUT,   INT_L2_OUT);
 N_inst  : E_VERZOEGERN PORT MAP (CLK, B_IMPULS, S_IN,         INT_N_OUT);
 
 INT_TMP(0) <= R_IN;
 INT_TMP(1) <= L_IN;

 with INT_TMP select
   S_OUT  <= (not N_IN) and INT_N_OUT           when "00",
             (not N_IN) and INT_N_OUT           when "11",
             (not N_IN) and (S_IN and A_IMPULS) when "01",
             (not N_IN) and INT_L2_OUT          when "10";
             
end A_SHIFTING;




