--------------------------------------------------------------------------------
-- [VHDL Praktikum SS2004]
--
-- Aufgabe 3:     Minima-Rechenwerk
-- Entity:        E_MINIMA (Top-Level-Entity)               
--
-- Andreas Schibilla (ii4900)
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;


entity E_BR is    
    port (
        CLK:      in  std_logic; 
        RST:      in  std_logic;
        BZ_IN:    in  std_logic;
        RAM_IN:   in  std_logic;
        E_IN:     in  std_logic;
        A_IMPULS: in  std_logic;
        S_OUT:    out std_logic;
        D_OUT:    out STD_LOGIC_VECTOR (19 DOWNTO 0)
    );
end E_BR;


architecture A_BR of E_BR is
component BR_SHIFTREG
   PORT
   (
      clock       : IN STD_LOGIC ;
      enable      : IN STD_LOGIC ;
      shiftin     : IN STD_LOGIC ;
      load        : IN STD_LOGIC ;
      data        : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
      q           : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
      shiftout    : OUT STD_LOGIC 
   );
end component;

begin      
 BR_SHIFTREG_inst : BR_SHIFTREG PORT MAP (
      clock       => CLK,
      enable      => RST or A_IMPULS,
      shiftin     => (BZ_IN and (not E_IN)) or (RAM_IN and E_IN), 
      load        => RST,
      data        => "10000000000000100001",
      q           => D_OUT,
      shiftout    => S_OUT
 );

end A_BR;




