--------------------------------------------------------------------------------
-- [VHDL Praktikum SS2004]
--
-- Aufgabe 3:     Minima-Rechenwerk
-- Entity:        E_MINIMA (Top-Level-Entity)               
--
-- Andreas Schibilla (ii4900)
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;


entity E_SR is    
    port (
        CLK:         in  std_logic;
        RST:         in  std_logic;
        B_IMPULS:    in  std_logic;
        ACCUBIT_IN:  in  std_logic;
        REG_IN:      in  std_logic_vector(19 downto 0);
        E_OUT:       out std_logic;
        F_OUT:       out std_logic;
        P_OUT:       out std_logic;
        Q_OUT:       out std_logic;
        N_OUT:       out std_logic;
        R_OUT:       out std_logic;
        L_OUT:       out std_logic;
        C_OUT:       out std_logic;
        A_OUT:       out std_logic;
        S_OUT:       out std_logic;
        U_OUT:       out std_logic;
        H_OUT:       out std_logic;
        ADDR_OUT:    out std_logic_vector (7 downto 0)
    );
end E_SR;


architecture A_SR of E_SR is
type   t_srzustand is (LADEN, IDLE);

signal INT_REG       : std_logic_vector(19 downto 0);
signal INT_ACCUBIT   : std_logic;
signal INT_OK        : std_logic; 
signal INT_ZUSTAND   : t_srzustand;

begin      
 INT_OK <= ( (not INT_REG(17)) or (INT_REG(17) and (not INT_ACCUBIT)) ) and 
           ( (not INT_REG(16)) or (INT_REG(16) and INT_ACCUBIT)       ); 
 
 E_OUT    <= INT_OK and INT_REG(19);
 F_OUT    <= INT_OK and INT_REG(18);
 P_OUT    <= INT_REG(17);
 Q_OUT    <= INT_REG(16);
 N_OUT    <= INT_OK and INT_REG(15);
 R_OUT    <= INT_OK and INT_REG(14);
 L_OUT    <= INT_OK and INT_REG(13);
 C_OUT    <= INT_OK and INT_REG(12);
 A_OUT    <= INT_OK and INT_REG(11);
 S_OUT    <= INT_OK and INT_REG(10);
 U_OUT    <= INT_OK and INT_REG(9);
 H_OUT    <= INT_OK and INT_REG(8);
 ADDR_OUT <= INT_REG(7 downto 0);
 
 
 P1: process(CLK, RST, B_IMPULS)
 begin
 
   if RST = '1' then
        INT_ZUSTAND <= LADEN;
        
   elsif rising_edge(CLK) then
    
        case INT_ZUSTAND is         
           when LADEN  => if B_IMPULS = '1' then
                            INT_REG     <= REG_IN;
                            INT_ACCUBIT <= ACCUBIT_IN;
                            INT_ZUSTAND <= IDLE;
                          end if;
           when IDLE =>   if B_IMPULS = '0' then
                            INT_ZUSTAND <= LADEN;
                          end if;
                            
        end case;
     
   end if;
 end process P1; 

 
end A_SR;




